package com.delivery.system.controller;

import com.delivery.system.domain.UserType;
import com.ruoyi.common.core.constant.SecurityConstants;
import com.ruoyi.common.core.domain.R;
import com.ruoyi.common.core.web.controller.BaseController;
import com.ruoyi.common.core.web.domain.AjaxResult;
import com.ruoyi.system.api.SysUserServiceFeign;
import com.ruoyi.system.api.domain.SysUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;

/**
 * @author jty
 */
@RequestMapping("/user/")
@RestController
@ResponseBody
public class UserController extends BaseController {
    String sC = SecurityConstants.INNER;

    @Autowired
    SysUserServiceFeign userService;

    @GetMapping("/test")
    public R<String> test() {
        return R.ok("Succeed");
    }

    @GetMapping(value = {"/{id}","/"})
    public AjaxResult getInfo(@PathVariable(value = "id", required = false) Long userId) {
        return userService.getInfo(userId, sC);
    }

    @PostMapping("/register")
    public R<Boolean> register(@RequestBody SysUser sysUser, @RequestParam UserType userType) {
        String username = sysUser.getUserName();
        sysUser.setDeptId(100L);
        if (userType == null) {
            return R.fail("保存用户'" + username + "'失败，未知用户类型");
        }
        sysUser.setRoleId(userType.getId());
        return userService.register(sysUser, sC);
    }

    @GetMapping("getInfo")
    public AjaxResult getInfo() {
        return userService.getInfo(sC);
    }

    @PutMapping
    public AjaxResult edit(@Validated @RequestBody SysUser user) {
        return userService.edit(user, sC);
    }
}

